#!/usr/local/bin/perl

require "cgi-lib.pl";

sub GetDirName{
  local ($ret) = @_;
  $ret =~ s/\//__/g;
  $ret =~ s/\./++/g;
  if (-e $ret) {
    local ($i) = 1;
    while (-e ($ret.".".$i)){
	$i = $i + 1;
    }
    return $ret.".".$i;
  }
  else{
    return $ret;
  }
}

sub ExecShow{
	local ($command) = @_;
	open(STATE, "$command 2>&1 |");
	while(<STATE>){
		if ($debug){
			print "$_ <br>";
		}
	}
	close(STATE);
}

MAIN:
{
  $debug = 1;
  if($debug){
	  print &PrintHeader;
	  print &HtmlTop;
	  print &PrintEnv;
  }

  # Read in all the variables set by the form
  &ReadParse(*input);

  $ENV{'PATH'} = $ENV{'PATH'}.":"."/usr/local/bin";
  $ENV{'GS_LIB'} = "/usr/local/share/ghostscript/6.01/lib/pdfeof.ps";
  $url=$input{'url'};

  chdir "temp";

  $dirname=GetDirName($url);
  if( mkdir $dirname, 0755 ){
	chdir $dirname;
	ExecShow("wget -nd $url");
	
	open(X, "ls |");
	$fname=<X>;
	close X;

	chomp($fname);

	if(lc(substr($fname, -2, 2)) eq "gz"){
		ExecShow("gunzip $fname");
		chop($fname);chop($fname);chop($fname);
	}

	open(OUTPUT, ">index.html");

	print OUTPUT  &HtmlTop;
	print OUTPUT  "Translated from $url<br>";
	print OUTPUT  "File before translation: $fname<br>";
	
	ExecShow("gs -dNOPAUSE -dBATCH -sDEVICE=pnggray -r180x180 -sOUTPUTFILE=page%d.png -f $fname");	
	open(LIST, "ls -l *.png |");
	while(<LIST>){
		print OUTPUT "$_<br>";
	}
	close LIST;

	$j=1;
	while(-e "page".$j.".png"){
		print OUTPUT  "<IMG SRC=page$j.png></IMG><br>";
		$j=$j+1;
	}

	print OUTPUT &HtmlBot;

	close OUTPUT;

	chmod 0777, ".";
	chmod 0666, "$dirname/*";
#Redirect
      	print	"Location: $ENV{'HTTP_REFERER'}temp/$dirname/index.html\n" .
		"\n";

  }

}

